package ca.carleton.gcrc.couch.client;

import java.util.List;

import net.sf.json.JSON;
import net.sf.json.JSONArray;
import net.sf.json.util.JSONUtils;

public class CouchQuery {

	private String viewName = null;
	private String listName = null;
	private String startKey = null;
	private String endKey = null;
	private String keys = null;
	private String limit = null;
	private String includeDocs = null;
	
	public String getViewName() {
		return viewName;
	}
	public void setViewName(String viewName) {
		this.viewName = viewName;
	}
	
	public String getListName() {
		return listName;
	}
	public void setListName(String listName) {
		this.listName = listName;
	}
	
	public String getStartKey() {
		return startKey;
	}
	public void setStartKey(String startKey) {
		this.startKey = JSONUtils.valueToString(startKey);
	}
	public void setStartKey(JSON startKey) {
		this.startKey = startKey.toString();
	}
	
	public String getEndKey() {
		return endKey;
	}
	public void setEndKey(String endKey) {
		this.endKey = JSONUtils.valueToString(endKey);
	}
	public void setEndKey(JSON endKey) {
		this.endKey = endKey.toString();
	}
	
	public String getKeys() {
		return keys;
	}
	public void setKeys(List<String> keys) {
		JSONArray arr = new JSONArray();
		for(String key : keys) {
			arr.add(key);
		}
		this.keys = arr.toString();
	}
	public void setKeys(JSON keys) {
		this.keys = keys.toString();
	}
	
	public String getLimit() {
		return limit;
	}
	public void setLimit(int limit) {
		this.limit = JSONUtils.valueToString(limit);
	}
	
	public String getIncludeDocs() {
		return includeDocs;
	}
	public void setIncludeDocs(boolean includeDocs) {
		this.includeDocs = JSONUtils.valueToString(includeDocs);
	}
}
