package ca.carleton.gcrc.couch.client;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import net.sf.json.JSONArray;
import net.sf.json.JSONObject;

public class ReplicationStatus {

	static private Pattern patternTask = Pattern.compile("^(.*):\\s+(.*) -> (.*)$");
	
	static public ReplicationStatus parseActiveTask(JSONObject obj) {
		ReplicationStatus status = null;
		if( null != obj ) {
			String type = obj.optString("type");
			String task = obj.optString("task");
			if( null != type
			 && null != task ) {
				Matcher matcherTask = patternTask.matcher(task);
				if( matcherTask.matches() ) {
					String taskId = matcherTask.group(1);
					String source = matcherTask.group(2);
					String target = matcherTask.group(3);
					
					status = new ReplicationStatus(taskId, source, target);
				}
			}
		}
		return status;
	}
	
	static public ReplicationStatus findReplicationTask(
			JSONArray tasks
			,String source
			,String target
			) {

		for(int i=0,e=tasks.size(); i<e; ++i) {
			JSONObject task = tasks.getJSONObject(i);
			ReplicationStatus status = ReplicationStatus.parseActiveTask(task);
			if( null != status ) {
				if( source.equals(status.getSource())
				 && target.equals(status.getTarget()) ) {
					return status;
				}
			}
		}
		
		return null;
	}
	
	private String taskId = null;
	private String source = null;
	private String target = null;

	private ReplicationStatus(
			String taskId
			,String source
			,String target
			) {
		this.taskId = taskId;
		this.source = source;
		this.target = target;
	}

	public String getTaskId() {
		return taskId;
	}

	public String getSource() {
		return source;
	}

	public String getTarget() {
		return target;
	}
}
